﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1TrueDBGrid;

namespace FilterDropDown_TDBG
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1TrueDBGrid1.DataSource = GetDataTable();

            var col = c1TrueDBGrid1.Columns["Name"];
            col.FilterDropdown = true;
            col.FilterMultiSelect = true;
            col.FilterEscape = "";
            col.FilterDropdownText = "(alle)";
            col.FilterApplyText = "Anw.";
            col.FilterCancelText = "Abbr.";
            col.FilterClearText = "Lösch.";

            c1TrueDBGrid1.MouseUp += C1TrueDBGrid1_MouseUp;
        }

        private void C1TrueDBGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            var displayColumn = c1TrueDBGrid1.ColContaining(e.X);

            if (displayColumn == -1) return;

            var col = c1TrueDBGrid1.FocusedSplit.DisplayColumns[displayColumn].DataColumn;

            //if required column
            if (col.Caption == "Name")
            {
                //access the filter dropdown form
                foreach (Form form in Application.OpenForms)
                {
                    if (form.Name == "FilterEditorForm" & form.GetType().ToString() == "C1.Win.C1TrueDBGrid.FilterEditorForm")
                    {
                        /*customize filter form buttons*/

                        var toolstrip = form.Controls[0] as ToolStrip;

                        toolstrip.Items["_btnApplyFilter"].Text = col.FilterApplyText;
                        toolstrip.Items["_btnCancel"].Text = col.FilterCancelText;
                        toolstrip.Items["_btnClearFilter"].Text = col.FilterClearText;

                        toolstrip.Items["_btnTextFilter"].Visible = false;
                    }
                }
            }
        }        

        /// <summary>
        /// Sample DataTable for the Grid
        /// </summary>
        private DataTable GetDataTable()
        {
            DataTable dt = new DataTable("Customers");
            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Department", typeof(string));
            dt.Columns.Add("Sex", typeof(string));
            dt.Columns.Add("Salary", typeof(decimal));
            dt.Columns.Add("Check", typeof(bool));

            dt.Rows.Add(1, "Peter", "Mgmt", "M", 5000, 0);
            dt.Rows.Add(2, "George", "ACC", "M", 4000, 0);
            dt.Rows.Add(3, "Frank", "IT", "M", 4500, 0);
            dt.Rows.Add(4, "Linda", "IT", "F", 4000, 0);
            dt.Rows.Add(5, "Fink", "ACC", "M", 3000, 0);
            dt.Rows.Add(6, "Lucy", "ACC", "F", 5000, 0);

            return dt;
        }
    }
}
